package org.jboss.seam.cache;

/**
 * @author Sebastian Hennebrueder
 */

public interface Cache<T> {

  /**
   * @return - the instance of the Cache implementation
   */
  T getDelegate();

  void start() throws Exception;

  void stop();

  String getCfgResourceName();

  void setCfgResourceName(String cfgResourceName);

  String toString();

  Object get(String key);

  Object get(String region, String key);
  
  void addOrUpdate(String key, Object object);

  void addOrUpdate(String region, String key, Object object);

  void remove(String key);

  void remove(String region, String key);

  void clear();

}
