package org.jboss.seam.cache;

import org.jboss.cache.aop.PojoCache;
import org.jboss.cache.*;
import org.jboss.cache.CacheException;
import org.jboss.seam.log.LogProvider;
import org.jboss.seam.log.Logging;

/**
 * JBoss cache (alias TreeCache) is suitable for simple objects which do not require a per field synchronization like
 * the JBoss Pojo Cache. It requires less memory and is faster as the PojoCache.
 *
 * This version of the cache provider is suitable for JBoss Cache 2.x
 *
 * @author Sebastian Hennebrueder
 */

public class JbossCacheProvider
//        implements Cache<Cache>
{

//  private Cache jbossCache;
//
//  private static final LogProvider log = Logging.getLogProvider(JbossTreeCacheProvider.class);
//
//  public static final String defaultCacheRegion = "org.jboss.seam.cache.DefaultCache";
//
//  private String cfgResourceName;
//
//  private Fqn buildFqn(String... path) {
//    StringBuilder builder = new StringBuilder();
//    for (String s : path) {
//      builder.append('/').append(s);
//    }
//    return Fqn.fromString(builder.toString());
//  }
//
//  public void start() throws org.jboss.seam.cache.CacheException {
//    log.debug("starting JBoss tree cache");
//
//    try {
//      CacheFactory factory = new DefaultCacheFactory();
//
//      jbossCache = factory.createCache("cache-configuration.xml");
//    } catch (Exception e) {
//      throw new org.jboss.seam.cache.CacheException("Error starting JBoss tree cache", e);
//    }
//  }
//
//  public void stop() {
//    log.debug("stopping JBoss tree cache");
//    jbossCache.stop();
//    jbossCache.destroy();
//    jbossCache = null;
//  }
//
//  public String getCfgResourceName() {
//    return cfgResourceName;
//  }
//
//  public void setCfgResourceName(String cfgResourceName) {
//    this.cfgResourceName = cfgResourceName;
//  }
//
//  public Object get(String key) {
//    try {
//      return treeCache.get(buildFqn(defaultCacheRegion, key));
//    } catch (CacheException e) {
//      throw new org.jboss.seam.cache.CacheException(String.format("Cache throw exception when trying to get %s.", key),
//              e);
//    }
//  }
//
//
//  public Object get(String region, String key) {
//    try {
//      return treeCache.get(buildFqn(region, key));
//    } catch (CacheException e) {
//      throw new org.jboss.seam.cache.CacheException(
//              String.format("Cache throw exception when trying to get %s from region %s.", key, region), e);
//    }
//  }
//
//  public void addOrUpdate(String key, Object object) {
//    addOrUpdate(defaultCacheRegion, key, object);
//  }
//
//  public void addOrUpdate(String region, String key, Object object) {
//    try {
//      treeCache.put(buildFqn(region),key,
//              object);
//    } catch (CacheException e) {
//      throw new org.jboss.seam.cache.CacheException(
//              String.format("JBoss Cache throw exception when adding object for key %s to region %s", key, region));
//    }
//  }
//
//
//  public void remove(String key) {
//    remove(defaultCacheRegion,key);
//  }
//
//  public void remove(String region, String key) {
//    try {
//      treeCache.remove(buildFqn(region, key));
//    } catch (CacheException e) {
//      throw new org.jboss.seam.cache.CacheException(
//              String.format("JBoss Cache throw exception when removing object for key %s in region %s", key, region));
//    }
//
//  }
//
//  public void clear() {
//    try {
//      Node node = treeCache.get(buildFqn(defaultCacheRegion));
//      node.clear();
//    } catch (CacheException e) {
//      throw new org.jboss.seam.cache.CacheException(
//              String.format("JBoss Cache throw exception when clearing default cache."));
//    }
//  }
//
//  public void clear(String region) {
//    try {
//      Node node = treeCache.get(buildFqn(region));
//      node.clear();
//    } catch (CacheException e) {
//      throw new org.jboss.seam.cache.CacheException(
//              String.format("JBoss Cache throw exception when clearing region %s.", region));
//    }
//  }
//
//  public JbossCacheProvider(PojoCache treeCache) {
//    this.treeCache = treeCache;
//  }
//
//  /**
//   * @return - the instance of the Cache implementation
//   */
//  public TreeCache getDelegate() {
//    return treeCache;
//  }
}