package org.jboss.seam.cache;

import org.jboss.seam.Component;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Install;
import static org.jboss.seam.annotations.Install.BUILT_IN;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.Unwrap;
import org.jboss.seam.annotations.intercept.BypassInterceptors;
import org.jboss.seam.contexts.Contexts;

/**
 *
 * @author Sebastian Hennebrueder
 */

@Name("org.jboss.seam.cache.pagefragmentcache")
@Scope(ScopeType.APPLICATION)
@BypassInterceptors
@Install(value = false, precedence = BUILT_IN)
public class PageFragmentCache {
  private Cache provider;

  @Unwrap
  public Cache getProvider() {
    return provider;
  }

  public void setProvider(Cache provider) {
    this.provider = provider;
  }

  public static Cache instance() {
    if (!Contexts.isApplicationContextActive()) {
      throw new IllegalStateException("No active application scope");
    }
    return (Cache) Component.getInstance("org.jboss.seam.cache.pagefragmentcache", ScopeType.APPLICATION);
  }
}
