package org.jboss.seam.statistics;

/**
 * @author Sebastian Hennebrueder
 */

public interface StatisticsGenerator {
	/**
	 * Creates a String printing a short String with statics collected from this Service
	 * Sample:
	 * Cache statistics: total: 10,000 cache hits: 600 cache miss: 9,940
	 *
	 * @return - The report as a String, this may contain LineBreaks
	 */
	String createReport();

	/**
	 * Statistics can be ordered or filtered by group, the group name must not be null
	 * @return
	 */
	String getStatisticGroupname();
}
